/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Player 饹(ץ쥤䡼Υ饹)Υ饤֥                       */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "PlayerP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

int PlayerGetState(Player p)            {return (p->state        );}
int PlayerSetState(Player p, int state) {return (p->state = state);}
Path PlayerGetPath(Player p)            {return (p->path       );}
Path PlayerSetPath(Player p, Path path) {return (p->path = path);}
Tank PlayerGetTank(Player p)            {return (p->tank       );}
Tank PlayerSetTank(Player p, Tank tank) {return (p->tank = tank);}
char * PlayerGetName(Player p) {return (p->name);}
int PlayerGetColorNumber(Player p) {return (p->color_number);}

int PlayerGetWin( Player p) {return (   p->win  );}
int PlayerIncWin( Player p) {return (++(p->win ));}
int PlayerGetLose(Player p) {return (   p->lose );}
int PlayerIncLose(Player p) {return (++(p->lose));}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Player PlayerCreate(char * name, Path path, int state)
{
  static int color_number = 1;
  Player player;

  player = (Player)malloc(sizeof(_Player));
  if (player == NULL) ErrorExit("Cannot create player.");

  player->win  = 0;
  player->lose = 0;
  if (name) player->name = strdup(name);
  else      player->name = "Who am I?";
  player->path = path;
  player->tank = NULL;
  player->state = state;
  player->color_number = color_number++;

  return (player);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Player PlayerDestroy(Player player)
{
  if (player == NULL) return (NULL);

  if (player->name) free(player->name);
  if (player->path) PathDestroy(player->path);
  if (player->tank) player->tank = NULL; /* ƤϤʤ */
  free(player);

  return (NULL);
}

/*===========================================================================*/
/* ǡ                                                            */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ѥǡκ                                                        */
/*---------------------------------------------------------------------------*/

char * PlayerMakeData(Player player, char * p)
{
  if (!player) return (NULL);
  if (!p     ) return (NULL);

  sprintf(p, PLAYER_DATA "\t%d %d %d %s %d\n",
	  player->state, player->win, player->lose,
	  player->name, player->color_number);

  while (*(p++) != '\n') { /* None */ }
  *p = '\0';

  return (p);
}

/*---------------------------------------------------------------------------*/
/* ǡɤ߹                                                      */
/*---------------------------------------------------------------------------*/

char * PlayerReadData(Player player, char * p)
{
  char command[30];
  char name[50];

  if (!player) return (NULL);
  if (!p     ) return (NULL);

  sscanf(p, "%s\t%d %d %d %s %d\n",
	 command, &(player->state), &(player->win), &(player->lose),
	 name, &(player->color_number));

  if (player->name) free(player->name);
  player->name = strdup(name);

  while (*(p++) != '\n') { /* None */ }

  return (p);
}

/*---------------------------------------------------------------------------*/
/* ץ쥤䡼˥ǡ                                                */
/*---------------------------------------------------------------------------*/

int PlayerSendMessageToAllPlayers(SubstanceList player_list,
				  char * message, int len)
{
  Player player;

  if (len <= 0) len = strlen(message);

  for (SubstanceListSetCurrentToStart(player_list);
       !SubstanceListIsCurrentEndEdge(player_list);
       SubstanceListMoveCurrentToNext(player_list)) {
    player = (Player)SubstanceListGetSubstance(player_list);
    if (PlayerGetState(player) != PLAYER_ACTIVE) continue;
    PathSendCharacters(PlayerGetPath(player), message, len);
  }
  return (0);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
