/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Tank 饹(֤Υ饹)Υ饤֥()                       */
/*****************************************************************************/

#ifndef _NADAR_SHARE_TANK_H_INCLUDED_
#define _NADAR_SHARE_TANK_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Tank * Tank; /* Tank 饹 */

#include "configure.h"

#include "etc.h"
#include "Substance.h"
#include "Stage.h"
#include "Map.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

#define TANK_WAIT      0
#define TANK_ACTIVE    1
#define TANK_EXPLOSION 2
#define TANK_EXPLOSING 3
#define TANK_DESTROY   4

#define TANK_NO_ACTION      0
#define TANK_GO_FORWARD     1
#define TANK_GO_BACKWARD    2
#define TANK_TURN_LEFT      4
#define TANK_TURN_RIGHT     8
#define TANK_FIRE_CANON    16
#define TANK_FIRE_MISSILE  32

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

double TankGetX(Tank tank);
double TankGetY(Tank tank);
int TankGetAngle(Tank tank);

int TankGetState(Tank tank);
int TankSetState(Tank tank, int state);
int TankGetAction(Tank tank);
int TankSetAction(Tank tank, int action);

Player TankGetPlayer(Tank tank);

int TankGetCanonNumber(Tank tank);
int TankGetCanonActiveNumber(Tank tank);
int TankGetMissileNumber(Tank tank);
int TankGetMissileActiveNumber(Tank tank);

int TankGetDestroyTimer(Tank tank);
int TankSetDestroyTimer(Tank tank, int t);
int TankDecDestroyTimer(Tank tank);

int TankIncCanon(Tank tank);
int TankDecCanon(Tank tank);
int TankIncMissile(Tank tank);
int TankDecMissile(Tank tank);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Tank TankCreate(double x, double y, int angle, Player player, int state);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Tank TankDestroy(Tank tank);

/*===========================================================================*/
/* ư                                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֤ư                                                                */
/*---------------------------------------------------------------------------*/

int TankAct(Tank tank, Stage stage);

/*===========================================================================*/
/* ǡ                                                            */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ѥǡκ                                                        */
/*---------------------------------------------------------------------------*/

char * TankMakeDrawData(Tank tank, char * p);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_TANK_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
